
/***************************************************************************
*
*   Copyright (c) 1998, 1999 Timpanogas Research Group, Inc.
*   895 West Center Street
*   Orem, Utah  84057
*   jmerkey@timpanogas.com
*
*   This program is free software; you can redistribute it and/or modify it
*   under the terms of the GNU General Public License as published by the
*   Free Software Foundation, version 2, or any later version.
*
*   This program is distributed in the hope that it will be useful, but
*   WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   General Public License for more details.
*
*   You are free to modify and re-distribute this program in accordance
*   with the terms specified in the GNU Public License.  The copyright
*   contained in this code is required to be present in any derivative
*   works and you are required to provide the source code for this
*   program as part of any commercial or non-commercial distribution.
*   You are required to respect the rights of the Copyright holders
*   named within this code.
*
*   jmerkey@timpanogas.com and TRG, Inc. are the official maintainers of
*   this code.  You are encouraged to report any bugs, problems, fixes,
*   suggestions, and comments about this software to jmerkey@timpanogas.com
*   or linux-kernel@vger.rutgers.edu.  New releases, patches, bug fixes, and
*   technical documentation can be found at www.timpanogas.com.  TRG will
*   periodically post new releases of this software to www.timpanogas.com
*   that contain bug fixes and enhanced capabilities.
*
*   Original Authorship      :
*      source code written by Jeff V. Merkey, TRG, Inc.
*
*   Original Contributors    :
*      Jeff V. Merkey, TRG, Inc.
*      Darren Major, TRG, Inc.
*      Alan Cox, RedHat Software, Inc.
*
****************************************************************************
*
*
*   AUTHOR   :  Jeff V. Merkey (jmerkey@timpanogas.com)
*   FILE     :  MMAP.C
*   DESCRIP  :  FENRIS VFS Memory Mapping Module for Linux
*   DATE     :  December 6, 1998
*
*
***************************************************************************/

#include "globals.h"

// we use the default generic_file_mmap function to provide native linux mmap
// file support on 2.0/2.2 -- page cache on 2.4.  (Andi Klein@suse.de stated
// in an email on the mailing list that  NWFS should be integrated more
// tightly with the mm in linux like a true local file such as EXT2).

#if (LINUX_24)

/**************************

//
//  The Page Cache Interface is still being tested.  Leave this
//  section uncommented.  We are merging the VM Cache Manager Code
//  from the Windows 2000 code base since it provides a page mapped
//  interface to the file system.
//

int nwfs_writepage(struct dentry *dentry, struct page *page)
{
    return block_write_full_page(page, nwfs_get_block);
}

int nwfs_readpage(struct dentry *dentry, struct page *page)
{
    return block_read_full_page(page, nwfs_get_block);
}

int nwfs_prepare_write(struct file *file, struct page *page, unsigned from, unsigned to)
{
    return block_prepare_write(page, from, to, nwfs_get_block);
}

int nwfs_bmap(struct address_space *mapping, long block)
{
    return generic_block_bmap(mapping, block, nwfs_get_block);
}

struct address_space_operations nwfs_aops =
{
    readpage:         nwfs_readpage,
    writepage:        nwfs_writepage,
    prepare_write:    nwfs_prepare_page,
    commit_write:     generic_commit_write,
    bmap:	      nwfs_bmap,
};

***************/

#endif

#if (LINUX_22)
#endif

#if (LINUX_20)
#endif
